AddDamageType("OraLeft",   '<bitmap:add-ons/Weapon_Star_Platinum/CI_LORA>',    '%2 <bitmap:add-ons/Weapon_Star_Platinum/CI_LORA> %1',0.75,1);
AddDamageType("OraRight",   '<bitmap:add-ons/Weapon_Star_Platinum/CI_RORA>',    '%2 <bitmap:add-ons/Weapon_Star_Platinum/CI_RORA> %1',0.75,1);
datablock AudioProfile(ORAORAORAORASound)
{
	filename = "./ORAORAORAORA.wav";
	description = AudioCloseLooping3d;
	preload = true;
};
datablock AudioProfile(OREWASTANDATOSound)
{
	filename = "./OREWASTANDATO.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(IMPACTSound)
{
	filename = "./IMPACT.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock AudioProfile(ORASound)
{
	filename = "./ORA.wav";
	description = AudioClosest3d;
	preload = false;
};
datablock ExplosionData(FistImpactExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = IMPACTSound;

   particleEmitter = swordExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.0 0.2 0.6";
   lightEndColor = "0 0 0";

   damageRadius = 0.1;
   radiusDamage = 1;

   impulseRadius = 1.5;
   impulseForce = 1000;
};
datablock ProjectileData(leftORAProjectile)
{
   directDamage        = 5;
   directDamageType  = $DamageType::OraLeft;
   radiusDamageType  = $DamageType::OraLeft;
   explosion           = FistImpactExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 25;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 150;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   standEffect = true;
   uiName = "LOra";
   projectileShapeName = "./LORAORA.dts";
};
datablock ProjectileData(rightORAProjectile)
{
   directDamage        = 5;
   directDamageType  = $DamageType::OraRight;
   radiusDamageType  = $DamageType::OraRight;
   explosion           = FistImpactExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 25;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 150;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   standEffect = true;
   uiName = "ROra";
   projectileShapeName = "./RORAORA.dts";
};
datablock ItemData(OREWASTANDATOItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./ORAORAORAORA.dts";
	iconName = "./Icon_StarPlatinum";

	 // Basic Item Properties
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Star Platinum";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = OREWASTANDATOImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(StarPlatinumImage)
{
	// Basic Item properties
	emap = true;
	shapeFile = "./ORAORAORAORA.dts";

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 7;
	offset = "0 -0.35 0.35";
	rotation = eulerToMatrix("0 0 180");

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	eyeOffset = "0 0 0";

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = OREWASTANDATOItem;
	ammo = " ";
	projectile = leftORAProjectile;
	rProjectile = rightORAProjectile;
	projectileType = Projectile;

	//melee particles shoot from eye node for consistancy
	melee = true;
	doRetraction = false;
	//raise your arm up or not
	armReady = false;
   minShotTime = 10;

	//casing = " ";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]							= "Activate";
	stateTimeoutValue[0]					= 0.15;
	stateTransitionOnTimeout[0]		= "Ready";
};
datablock ShapeBaseImageData(OREWASTANDATOImage)
{
	// Basic Item properties
	emap = true;
	shapeFile = "base/data/shapes/empty.dts";

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 -0.35 0.35";
	rotation = eulerToMatrix("0 0 180");

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	eyeOffset = "0 0 0";

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = OREWASTANDATOItem;
	ammo = " ";
	projectile = leftORAProjectile;
	rProjectile = rightORAProjectile;
	projectileType = Projectile;

	//melee particles shoot from eye node for consistancy
	melee = true;
	doRetraction = false;
	//raise your arm up or not
	armReady = false;
	minShotTime = 10;

	//casing = " ";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]							= "Activate";
	stateTimeoutValue[0]					= 0.15;
	stateTransitionOnTimeout[0]		= "Ready";
	stateScript[0]							= "onDraw";

	stateName[1]							= "Ready";
	stateTransitionOnTriggerDown[1]	= "PreFire";
	stateAllowImageChange[1]			= true;

	stateName[2]							= "PreFire";
	stateScript[2]							= "ORARev";
	stateTimeoutValue[2]					= 0.01;
	stateTransitionOnTimeout[2] 		= "Fire";
	stateAllowImageChange[2]			= false;

	stateName[3]							= "Fire";
	stateTransitionOnTimeout[3]		= "CheckFire";
	stateTimeoutValue[3]					= 0.025;
	stateAllowImageChange[3]			= false;
	stateScript[3]							= "onFire";
	stateWaitForTimeout[3]				= true;

	stateName[4]							= "CheckFire";
	stateAllowImageChange[4]			= false;
	stateTransitionOnTriggerUp[4]		= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]							= "StopFire";
	stateTransitionOnTimeout[5]		= "Ready";
	stateTimeoutValue[5]					= 0.2;
	stateAllowImageChange[5]			= false;
	stateWaitForTimeout[5]				= true;
	stateScript[5]							= "ORAStop";
};
package ORAORAORAORA
{
	function vectorRelativeShift(%forwards,%up,%shift)
	{
		%xShift = getWord(%shift,0);
		%yShift = getWord(%shift,1);
		%zShift = getWord(%shift,2);
		%xMod = vectorScale(%forwards,%xShift);
		%yMod = vectorScale(vectorCross(%forwards,%up),%yShift);
		%zMod = vectorScale(%up,%zShift);
		return vectorAdd(%xMod,vectorAdd(%yMod,%zMod));
	}
	function player::isInsideReflectangle(%player, %object, %testAngle)
	{
		%testAngle = %testAngle*($pi/180);
		%playerPos = getWords(%player.getEyePoint(),0,1) SPC "0";
		%objPos = getWords(%object.getPosition(),0,1) SPC "0";
		
		%playerView = getWords(%player.getForwardVector(),0,1) SPC "0";
		%objectDisplacement = VectorSub(%objPos,%playerPos);
		
		%playerViewAngle = mATan(getWord(%playerView,1),getWord(%playerView,0));
		%objectDisplacementAngle = mATan(getWord(%objectDisplacement,1), getWord(%objectDisplacement,0));
		
		%deltaAngle = mAbs(%playerViewAngle - %objectDisplacementAngle);

		if(%deltaAngle > $pi)
			%deltaAngle = (2*$pi) - %deltaAngle;

		if(%deltaAngle > %testAngle/2)
			return false;

		return true;
	}
	function testForOra(%damageType) {
		return ($DamageType_Array[%damageType] $= "OraLeft" || $DamageType_Array[%damageType] $= "OraRight");
	}
	function player::damage(%obj, %sourceObject, %position, %damage, %damageType)
	{
		if(testForOra(%damageType) && %sourceObject.client.player == %obj)
			return;
		if(testForOra(%damageType)) {
			if(%obj.oraComboCounter < getSimTime()) {
				%obj.oraComboNumber = 0;
			}
			%obj.oraComboNumber += 1;
			if(%obj.oraComboNumber == 5) {
				%damage = 30;
				%oraComboNumer = 0;
				//%vector = vectorNormalize(%sourceObject.getVelocity());
				//%vector = vectorScale(%vector,5);
				%vector = vectorNormalize(vectorSub(%obj.getPosition(),%sourceObject.client.player.getPosition()));
				%vector = vectorScale(%vector,15);
				%vector = getWords(%vector,0,1) SPC "15";
				%obj.setVelocity(%vector);
				%sourceObject.client.player.playAudio(1,ORASound);
			}
			%obj.oraComboCounter = getSimTime() + 100;
		}
		parent::damage(%obj, %sourceObject, %position, %damage, %damageType);
	}
	function OREWASTANDATOImage::OnDraw(%this,%obj,%slot)
	{
		if(!%obj.hasOrad) {
			%obj.playAudio(%slot,OREWASTANDATOSound);
			%obj.hasOrad = true;
		}
	}
	function OREWASTANDATOImage::ORARev(%this,%obj,%slot)
	{
		%obj.playAudio(%slot,ORAORAORAORASound);
		%obj.mountImage(StarPlatinumImage,1);
	}
	function OREWASTANDATOImage::ORAStop(%this,%obj,%slot)
	{
		%obj.stopAudio(%slot);
		%obj.unmountImage(1);
	}
	function OREWASTANDATOImage::onFire(%this,%obj,%slot)
	{
		if(%obj.strikeTimer < getSimTime())
		{
			%projectile = %this.projectile;
			%spread = 0.025;
			%muzPointCore = %obj.getMuzzlePoint(%slot);
			%upVect = %obj.getUpVector();
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom()/2) * -10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);
			%subPos = VectorScale(%objectVelocity,0.005);
			if(!%obj.fireRightFist) {
				%p = new (%this.projectileType)()
				{
					dataBlock = %projectile;
					initialVelocity = %velocity;
					initialPosition = VectorAdd(%subPos,VectorAdd(%obj.getEyePoint(),vectorRelativeShift(%obj.getForwardVector(),%upVect,"0 -0.9 0")));
					sourceObject = %obj;
					sourceSlot = %slot;
					client = %obj.client;
				};
				MissionCleanup.add(%p);
				%obj.fireRightFist = true;
			} else {
				%projectile = %this.rProjectile;
				%vector = %obj.getMuzzleVector(%slot);
				%objectVelocity = %obj.getVelocity();
				%velocity = VectorAdd(%vector1,%vector2);
				%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				//(getRandom() - 0.5) * 10 * 3.1415926 * %spread
				%z = (getRandom()/2) * 10 * 3.1415926 * %spread;
				%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
				%velocity = MatrixMulVector(%mat, %velocity);

				%p = new (%this.projectileType)()
				{
					dataBlock = %projectile;
					initialVelocity = %velocity;
					initialPosition = VectorAdd(%subPos,VectorAdd(%obj.getEyePoint(),vectorRelativeShift(%obj.getForwardVector(),%upVect,"0 0.9 0")));
					sourceObject = %obj;
					sourceSlot = %slot;
					client = %obj.client;
				};
				MissionCleanup.add(%p);
				%obj.fireRightFist = false;
			}
			%obj.strikeTimer = getSimTime() + 25;
		}
		if(%obj.deflectDelay < getSimTime())
		{
			%eye = %obj.getHackPosition();
			%mask = $TypeMasks::ProjectileObjectType;
			InitContainerRadiusSearch(%eye, 3, %mask);
			while(%proj = containerSearchNext())
			{
				if(%proj.reflectMaster == %obj || %proj.getDataBlock().standEffect || !%obj.isInsideReflectangle(%proj,180))
					continue;
				%vel = vectorLen(%proj.getVelocity());
				if(%vel == 0)
					continue;
				%dir = getWords(%obj.getForwardVector(),0,1) SPC getWord(%obj.getEyeVector(),2);
				%vel = VectorScale(%dir,%vel);
				%p = new (%this.projectileType)()
				{
					dataBlock = %proj.getDataBlock();
					initialVelocity = %vel;
					initialPosition = %proj.getPosition();
					sourceObject = %obj;
					sourceSlot = %slot;
					client = %obj.client;
					reflectMaster = %obj;
				};
				MissionCleanup.add(%p);
				%proj.delete();
			}
			%obj.reflectTimer = getSimTime() + 150;
		}
	}
};
ActivatePackage(ORAORAORAORA);